#define BUILDING_AGGREGATE_PLUSPLUS_H 1

#include <Message.h>
#include <iostream.h>
#include <string.h>
#include "Vector++.h"
#include "Primitive++.h"
#include "Aggregate++.h"

#define AGGREGATE_SUBELEMENT 'VPs_'

bool transformobject(void *object, void *basis)
{
  ((primitivef *) object)->transform((basisf *)basis);
  return false;
};

bool translateobject(void *object, void *vector)
{
  ((primitivef *) object)->translate((vectorf *)vector);
  return false;
};

bool extractmessage(void *object, void *msg_archive)
{
  BMessage *msg_extract = new BMessage(AGGREGATE_SUBELEMENT);
  ((primitivef *) object)->Archive(msg_extract, true);
  ((BMessage *)msg_archive)->AddMessage("Subelements",msg_extract);
  return false;
};

bool drawobject(void *object)
{
  ((primitivef *) object)->draw();
  return false;
};

aggregatef::aggregatef()
  :BList()
{};

aggregatef::aggregatef(aggregatef *seed)
  :BList(seed->CountItems())
{
  *this = *seed;
};

aggregatef::aggregatef(aggregatef *seed, int extra)
  :BList(seed->CountItems() + extra)
{
  *this = *seed;
};

void aggregatef::transform(basisf basis)
{
  DoForEach(&transformobject, &basis);
};

void aggregatef::translate(vectorf vector)
{
  DoForEach(&translateobject, &vector);
};

void aggregatef::draw()
{
  DoForEach(&drawobject);
};

BArchivable *aggregatef::Instantiate(BMessage * msg_create)
{
  return new aggregatef(msg_create);
};


status_t aggregatef::Archive(BMessage *msg_send, bool deep) const
{
  primitivef::Archive(msg_send, deep);
    msg_send->AddString("GType","AGGREGATE");
    for(int index = 0; index < CountItems(); index++)
      extractmessage(ItemAt(index),msg_send);
    msg_send->AddInt32("Number",CountItems());
    msg_send->AddString("class","aggregatef");
  return B_OK;
};

aggregatef::aggregatef(BMessage *msg_data, primitivef *other(BMessage *))
  :BList()
{
  BMessage *msg_extract;
  int32 total;
  const char *typestr;
  msg_data->FindInt32("Number",&total);
  primitivef *toadd;
  for (int index = 0; index < total; index++)
  {
    msg_data->FindMessage("Subelements",index,msg_extract);
    
    msg_extract->FindString("GType",&typestr);
    if (strcmp(typestr,"POINT") == 0)
      toadd = (primitivef *) pointf::Instantiate(msg_extract);
    else if (strcmp(typestr,"TRIANGLE") == 0)
      toadd = (primitivef *) trianglef::Instantiate(msg_extract);
    else if (strcmp(typestr,"QUAD") == 0)
      toadd = (primitivef *) quadf::Instantiate(msg_extract);
    else if (strcmp(typestr,"AGGREGATE") == 0)
      toadd = (primitivef *) aggregatef::Instantiate(msg_extract);
    else if (other != NULL)
      toadd = (primitivef *) other(msg_extract);
    else break;
          
    AddItem(toadd);    
  };
};

aggregatef* aggregatef::operator +(aggregatef rhs)
{
  aggregatef *temp = new aggregatef(this, rhs.CountItems());
  for (int index = 0; index < rhs.CountItems(); index++)
    temp->AddItem(rhs.ItemAt(index));
  return temp;
};

bool aggregatef::operator << (primitivef *rhs)
{
  this->AddItem(rhs);
  return true;
};