//Basis++.h -- this is a vector basis in R3, object-oriented style.

#ifndef BASIS_PLUSPLUS_H
#define BASIS_PLUSPLUS_H

  #if BUILDNG_BASIS_PLUSPLUS_H
    #define BASIS_IMPEXP_TYPED __declspec(dllexport)
  #else
    #define BASIS_IMPEXP_TYPED __declspec(dllimport)
  #endif

#include "Vector++.h"

class BASIS_IMPEXP_TYPED basisf
{
  public:
    basisf();						//constructors
    basisf(vectorf, vectorf, vectorf);
    basisf(basisf *);
    
    void replacee(vectorf);			//replacement functions
    void replacef(vectorf);
    void replaceg(vectorf);
    void orthogonalize();			//fix the vectors so they are orthogonal
    void unitize();					//make all the vectors unitary.
    void dextrize();				//make right-handed.
    bool orthogonal();				//are they orthogonal?
    bool unitary();					//are they unitary?
    bool righthanded();
    
    void rotatex(float);			//rotations
    void rotatey(float);
    void rotatez(float);
    
    vectorf e, f, g;
  private:
    bool _ortho, _unit, _right;
};

BASIS_IMPEXP_TYPED vectorf operator <<(vectorf, basisf);
  //write a basisf's vectorf in standard notation.
BASIS_IMPEXP_TYPED vectorf operator >>(vectorf, basisf);
  //write a standard vectorf in basisf's notation

BASIS_IMPEXP_TYPED bool operator <=(vectorf &, basisf);

#endif