//Primitive graphics class -- all drawable objects have these properties.

#ifndef PRIMITIVE_PLUSPLUS_H
#define PRIMITIVE_PLUSPLUS_H

  #if BUILDNG_PRIMITIVE_PLUSPLUS_H
    #define PRIMITIVE_IMPEXP_TYPED __declspec(dllexport)
  #else
    #define PRIMITIVE_IMPEXP_TYPED __declspec(dllimport)
  #endif

#include "Vector++.h"
#include "Basis++.h"
#include <Archivable.h>

//This is an ADT.
class PRIMITIVE_IMPEXP_TYPED primitivef:public BArchivable
{
  public:    
    virtual void transform(basisf) = 0;
    virtual void translate(vectorf) = 0;
    virtual void draw() = 0;
    
    virtual status_t Archive (BMessage *, bool) const;
};

class PRIMITIVE_IMPEXP_TYPED quadf:public primitivef //, BArchivable
{
  public:
    quadf(); quadf(vectorf, vectorf, vectorf, vectorf);
    quadf(quadf *); quadf(BMessage *);
    
    void transform(basisf);
    void translate(vectorf);
    
    static BArchivable *Instantiate(BMessage *);
    virtual status_t Archive(BMessage *, bool) const;
    
    virtual void draw();
    
    vectorf vertices[4];
};

class PRIMITIVE_IMPEXP_TYPED trianglef:public primitivef
{
  public:
    trianglef(); trianglef(vectorf, vectorf, vectorf);
    trianglef(trianglef*); trianglef(BMessage *);
    
    void transform(basisf);
    void translate(vectorf);
    
    static BArchivable *Instantiate(BMessage *);
    virtual status_t Archive(BMessage *, bool) const;    
    
    virtual void draw();    
    vectorf vertices[3];
};

class PRIMITIVE_IMPEXP_TYPED pointf:public primitivef
{
  public:
    pointf(); pointf(vectorf);
    pointf(pointf*); pointf(BMessage *);
    
    void transform(basisf);
    void translate(vectorf);

    static BArchivable *Instantiate(BMessage *);
    virtual status_t Archive(BMessage *, bool) const;    
    
    virtual void draw();
    
    vectorf location;
};

#endif